Attribute VB_Name = "Window_Caption"
Option Explicit

'==================================================================
'
' Window Caption Property
'
' 30 September 2001
'
' You're free in using this software, as long as the
' orignal copyright/author information remains intact.
' In other words, respecting the person(s) who made it
' possible for you to view/learn something of this software.
'
' Copyright  2001 - Diederik van der Boor
' http://www.codingdomain.com
'
'==================================================================


'------------------------------------------------------------------
' API's

Private Declare Function SetWindowText Lib "user32" Alias "SetWindowTextA" (ByVal hWnd As Long, ByVal lpString As String) As Long
Private Declare Function GetWindowText Lib "user32" Alias "GetWindowTextA" (ByVal hWnd As Long, ByVal lpString As String, ByVal cch As Long) As Long
Private Declare Function GetWindowTextLength Lib "user32" Alias "GetWindowTextLengthA" (ByVal hWnd As Long) As Long
Private Declare Function IsWindow Lib "user32" (ByVal hWnd As Long) As Long



'------------------------------------------------------------------
' Get Caption

Public Property Let WindowCaption(hWnd As OLE_HANDLE, NewValue As String)
  If SetWindowText(hWnd, NewValue) = 0 Then Error 5
End Property

Public Property Get WindowCaption(hWnd As OLE_HANDLE) As String
  Dim CapLen As Long
  Dim CapBuf As String
  If IsWindow(hWnd) = 0 Then Error 5
  CapLen = GetWindowTextLength(hWnd) + 1
  CapBuf = Space(CapLen)
  CapLen = GetWindowText(hWnd, CapBuf, CapLen)
  WindowCaption = Left(CapBuf, CapLen)
End Property


