Attribute VB_Name = "Window_Handles"
Option Explicit

'==================================================================
'
' Window Handles
'
' 30 September 2001
'
' You're free in using this software, as long as the
' orignal copyright/author information remains intact.
' In other words, respecting the person(s) who made it
' possible for you to view/learn something of this software.
'
' Copyright  2001 - Diederik van der Boor
' http://www.codingdomain.com
'
'==================================================================


'------------------------------------------------------------------
' API's

Private Declare Function GetParent Lib "user32" (ByVal hWnd As Long) As Long
Private Declare Function SetParent Lib "user32" (ByVal hWndChild As Long, ByVal hWndNewParent As Long) As Long
Private Declare Function GetDesktopWindow Lib "user32" () As Long
Private Declare Function IsWindow Lib "user32" (ByVal hWnd As Long) As Long
Private Declare Function FindWindow Lib "user32" Alias "FindWindowA" (ByVal lpClassName As String, ByVal lpWindowName As String) As Long
Private Declare Function WindowFromDC Lib "user32" (ByVal hDC As Long) As Long
Private Declare Function WindowFromPoint Lib "user32" (ByVal xPoint As Long, ByVal yPoint As Long) As Long
Private Declare Function GetFocus Lib "user32" () As Long
Declare Function SetFocus Lib "user32" (ByVal hWnd As Long) As Long

Private Declare Function GetDC Lib "user32" (ByVal hWnd As Long) As Long
Private Declare Function GetWindowDC Lib "user32" (ByVal hWnd As Long) As Long
Private Declare Function ReleaseDC Lib "user32" (ByVal hWnd As Long, ByVal hDC As Long) As Long



'------------------------------------------------------------------
' Desktop Window

Public Property Get WindowhWndDesktop() As Long
  WindowhWndDesktop = GetDesktopWindow()
End Property


'------------------------------------------------------------------
' The parent of a window

Public Property Get WindowhWndParent(hWnd As OLE_HANDLE) As OLE_HANDLE
  If IsWindow(hWnd) = 0 Then Error 5
  WindowhWndParent = GetParent(hWnd)
End Property

Public Property Let WindowhWndParent(hWnd As OLE_HANDLE, NewValue As OLE_HANDLE)
  If IsWindow(hWnd) = 0 Then Error 5
  If IsWindow(NewValue) = 0 And NewValue <> 0 Then Err.Raise 380
  If SetParent(hWnd, NewValue) = 0 Then Err.Raise 12345, "WindowhWndParent", "Could not attach to parent window!"
End Property


'------------------------------------------------------------------
' Does it exist?

Public Function WindowExists(hWnd As OLE_HANDLE) As Boolean
  WindowExists = IsWindow(hWnd) <> 0
End Function


'------------------------------------------------------------------
' Find a Window Handle

Public Function WindowhWnd(Optional PtX As Long, Optional PtY As Long, Optional hDC As OLE_HANDLE, Optional ClassName As String, Optional Caption As String) As OLE_HANDLE
  If PtX > 0 And PtY > 0 Then _
    WindowhWnd = WindowFromPoint(PtX, PtY)
  If WindowhWnd = 0 And hDC <> 0 Then _
    WindowhWnd = WindowFromDC(hDC)
  If WindowhWnd = 0 And Len(ClassName & Caption) Then _
    WindowhWnd = FindWindow(ClassName, Caption)
End Function


'------------------------------------------------------------------
' Window Device Context (mostly the Drawing Workspace)

Public Property Get WindowhDC(hWnd As OLE_HANDLE, Optional EntireWindowDC As Boolean) As OLE_HANDLE
  If IsWindow(hWnd) = 0 Then Error 5
  If Not EntireWindowDC Then
    WindowhDC = GetDC(hWnd)
  Else
    WindowhDC = GetWindowDC(hWnd)
  End If
End Property

Public Sub WindowReleaseDC(hWnd As OLE_HANDLE, hOpenedDC As OLE_HANDLE)
  If IsWindow(hWnd) = 0 Then Error 5
  If ReleaseDC(hWnd, hOpenedDC) = 0 Then Error 5
End Sub



'------------------------------------------------------------------
' Window that has the focus

Public Property Get WindowhWndFocus() As OLE_HANDLE
  WindowhWndFocus = GetFocus()
End Property

Public Property Let WindowhWndFocus(NewValue As OLE_HANDLE)
  If IsWindow(NewValue) = 0 Then Error 380
  If SetFocus(NewValue) = 0 Then Error 380
End Property
